<?php


namespace app\admin\controller;
use think\App;
use think\facade\Db;


class After extends \app\BaseController
{
    public $post=[];
    public function __construct(App $app)
    {
        parent::__construct($app);
        $this->post =$this->request->post();
    }

    public function create(){
         $outCode = isset($this->post['outCode']) &&$this->post['outCode']!=''?trim($this->post['outCode']) :"";
         if($outCode==''){
             return error_show(1004,"参数outCode 不能为空");
         }
         $order= Db::name("order_out")->where(["outCode"=>$outCode])->find();
         if(empty($order)){
             return error_show(1005,"未找到订单数据");
         }
        $order= Db::name("sale")->where(["orderCode"=>$order['orderCode'],"is_del"=>0])->find();
        if(empty($order)){
            return error_show(1005,"未找到订单数据");
        }
        $errorCode = isset($this->post['errorCode']) &&$this->post['errorCode']!=''?trim($this->post['errorCode']) :"";
        if($outCode==''){
            return error_show(1004,"参数errorCode 不能为空");
        }
        $error =Db::name('result_info')->where(["result_code"=>$errorCode,"is_del"=>0])->find();
        if(empty($error)){
            return error_show(1005,"未找到退货原因数据");
        }
        $num =isset($this->post['num']) &&$this->post['num']!=''?intval($this->post['num']) :"";
        if($num==""){
            return error_show(1004,"参数 num 不能为空或零");
        }
        $order_type =isset($this->post['order_type']) &&$this->post['order_type']!=''?intval($this->post['order_type']) :"";
//        if($order_type==""){
//            return error_show(1004,"参数 order_type 不能为空或零");
//        }
        $remark =isset($this->post['remark']) &&$this->post['remark']!=''?trim($this->post['remark']) :"";
        $except_code =isset($this->post['except_code']) &&$this->post['except_code']!=''?trim($this->post['except_code']) :"";
        $img = isset($this->post['img']) &&$this->post['img']!=''?trim($this->post['img']) :"";
        $token = isset($this->post['token'])&&$this->post['token']!='' ? trim($this->post['token']):"";
        if($token==''){
            return error_show(1005,"参数token不能为空");
        }
        $user =GetUserInfo($token);
        if(empty($user)||$user['code']!=0){
            return error_show(1002,"申请人数据不存在");
        }
        $rm= isset($user["data"]['id']) ?  $user["data"]['id'] : "";
        $ri= isset($user["data"]['nickname']) ?  $user["data"]['nickname'] : "";
        $returnCode=makeNo("RXS");
        Db::startTrans();
        try{
            $in = [
                "returnCode"=>$returnCode,
                "outCode"=>$outCode,
                "orderCode"=> $order['orderCode'],
                "good_code"=>$order['good_code'],
                "good_name"=>$order['good_name'],
                "customer_code"=>$order['customer_code'],
                "apply_id"=>$rm,
                "apply_name"=>$ri,
                'total_num'=>$order['send_num'],
                "error_code"=>$errorCode,
                "error_num"=>$num,
                "error_img"=>$img,
                "error_msg"=>$error['result'],
                "error_remark"=>$remark,
                "remark"=>'',
                "except_code"=>$except_code,
                "order_type"=>$order['order_type'],
                "status"=>0,
                "is_del"=>0,
                "addtime"=>date("Y-m-d H:i:s"),
                "updatetime"=>date("Y-m-d H:i:s")
            ];
            $create = Db::name("order_return")->insert($in);
            if($create){
                    Db::commit();
                    return app_show(0,"售后申请单新建成功");
            }
            Db::rollback();
            return error_show(1005,"售后申请单新建失败");
        }catch (\Exception $e){
            Db::rollback();
            return error_show(1005,$e->getMessage());
        }
    }

    public function list(){
        $page = isset($this->post['page']) && $this->post['page'] !=="" ? intval($this->post['page']):"1";
        $size = isset($this->post['size']) && $this->post['size'] !=="" ? intval($this->post['size']):"10";
        $where =[['a.is_del',"=",0]];
        $bkcode = isset($this->post['returnCode']) && $this->post['returnCode']!="" ? trim($this->post['returnCode']):"";
        if($bkcode!=""){
            $where[]=['a.returnCode',"like", "%{$bkcode}%"];
        }
        $out = isset($this->post['outCode']) && $this->post['outCode']!="" ? trim($this->post['outCode']):"";
        if($out!=""){
            $where[]=['a.outCode',"like", "%{$out}%"];
        }
        $status = isset($this->post['status']) && $this->post['status']!=="" ? intval($this->post['status']):"";
        if($status!==""){
            $where[]=['a.status',"=", $status];
        }
        $order_type = isset($this->post['order_type']) && $this->post['order_type']!=="" ? intval($this->post['order_type']):"";
        if($order_type!==""){
            $where[]=['a.order_type',"=", $order_type];
        }
        $orderCode = isset($this->post['orderCode']) && $this->post['orderCode']!="" ? trim($this->post['orderCode'])
            :"";
        if($orderCode!=""){
            $where[]=['a.orderCode',"like", "%{$orderCode}%"];
        }
        $good_code = isset($this->post['good_code']) && $this->post['good_code']!="" ? trim($this->post['good_code'])
            :"";
        if($good_code!=""){
            $where[]=['a.good_code',"like", "%{$good_code}%"];
        }
        $good_name = isset($this->post['good_name']) && $this->post['good_name']!="" ? trim($this->post['good_name'])
            :"";
        if($good_name!=""){
            $where[]=['a.good_name',"like", "%{$good_name}%"];
        }
        $customer_code = isset($this->post['customer_code']) && $this->post['customer_code']!="" ? trim($this->post['customer_code'])
            :"";
        if($customer_code!=""){
            $where[]=['a.customer_code',"like", "%{$customer_code}%"];
        }
        $except_code = isset($this->post['except_code']) && $this->post['except_code']!="" ? trim($this->post['except_code']):"";
        if($except_code!=""){
            $where[]=['a.except_code',"=", $except_code];
        }
        $apply_name = isset($this->post['apply_name']) && $this->post['apply_name']!="" ? trim($this->post['apply_name'])
            :"";
        if($apply_name!=""){
            $where[]=['a.apply_name',"like", "%{$apply_name}%"];
        }
        $start =isset($this->post['start'])&&$this->post['start']!='' ? $this->post['start']:"";
        if($start!==""){
            $where[]=['a.addtime',">=", $start];
        }
        $end =isset($this->post['end'])&&$this->post['end']!='' ? $this->post['end']:"";
        if($end!==""){
            $where[]=['a.addtime',"<=", $end];
        }
        $count=Db::name("order_return")->alias("a")->leftJoin("order_returninfo b","a.returnCode=b.returnCode")->where
        ($where)->count();
        $total = ceil($count/$size);
        $page = $total>=$page ? $page :$total;
        $list =Db::name("order_return")->alias("a")->leftJoin("order_returninfo b","a.returnCode=b.returnCode")->where($where)
            ->field("a.*,b.return_wsm,b.contactor,b.mobile,b.addr,b.addr_code,b.post_code,b.post_company,b.post_fee,b.gys_remark")->page($page,$size)
            ->order("addtime desc")->select();
        $data=[];
        foreach ($list as $value){
            $customer = Db::name("customer_info")->where(["companyNo"=>$value['customer_code']])->find();
            $value['customer_name'] = isset($customer['companyName']) ?trim($customer['companyName']):'';
            $data[]=$value;
        }
        return app_show(0,"获取成功",['list'=>$data,"count"=>$count]);
    }

    /**
     * @return \think\response\Json|void
     * @throws \think\db\exception\DataNotFoundException
     * @throws \think\db\exception\DbException
     * @throws \think\db\exception\ModelNotFoundException
     */
    public function  info(){
        $bkcode = isset($this->post['returnCode']) && $this->post['returnCode']!="" ? trim($this->post['returnCode']):"";
        if($bkcode==""){
          return error_show(1005,"参数returnCode 不能为空");
        }
        $info = Db::name("order_return")->alias("a")->leftJoin("order_returninfo b","a.returnCode=b.returnCode")
            ->field("a.*,b.return_wsm,b.contactor,b.mobile,b.addr,b.addr_code,b.post_code,b.post_company,b.post_fee,b.gys_remark")
            ->where(['a.returnCode'=>$bkcode])->find();
        if(empty($info)){
            return error_show(1005,"未找到售后数据");
        }
        $out =Db::name("order_out")->where(["outCode"=>$info['outCode']])->find();
        $info['out_num'] = isset($out['send_num'])?$out['send_num']:'';
        $customer = Db::name("customer_info")->where(["companyNo"=>$info['customer_code']])->find();
        $info['customer_name'] = isset($customer['companyName']) ?trim($customer['companyName']):'';
        return app_show(0,"获取成功",$info);
    }

    public function status(){
        $bkcode = isset($this->post['returnCode']) && $this->post['returnCode']!="" ? trim($this->post['returnCode']):"";
        if($bkcode==""){
            return error_show(1005,"参数returnCode 不能为空");
        }
        $info = Db::name("order_return")->where(['returnCode'=>$bkcode])->find();
        if(empty($info)){
            return error_show(1005,"未找到售后数据");
        }
        $status = isset($this->post['status']) && $this->post['status']!=="" ? intval($this->post['status'])
            :"";
        if($status===""){
            return error_show(1005,"参数status 不能为空");
        }
      $remark = isset($this->post['remark'])&&$this->post['remark']!=''?trim($this->post['remark']):"";
        if($remark!=''){
            $info['remark'] =$remark;
        }
        $info['status']=$status;
        $info['updatetime']=date("Y-m-d H:i:s");
        $up =Db::name("order_return")->save($info);
        if($up){
            return app_show(0,"更新成功");
        }else{
            return error_show(1004,"更新失败");
        }
    }

    /**
     * @return \think\response\Json|void
     * @throws \think\db\exception\DataNotFoundException
     * @throws \think\db\exception\DbException
     * @throws \think\db\exception\ModelNotFoundException
     */
    public function postfeed(){
        $bkcode = isset($this->post['returnCode']) && $this->post['returnCode']!="" ? trim($this->post['returnCode']):"";
        if($bkcode==""){
            return error_show(1005,"参数returnCode 不能为空");
        }
        $info = Db::name("order_return")->where(['returnCode'=>$bkcode])->find();
        if(empty($info)){
            return error_show(1005,"未找到售后数据");
        }
        $wsm_code = isset($this->post['wsm_code']) && $this->post['wsm_code']!="" ? trim($this->post['wsm_code']):"";
        if($wsm_code==""){
            return error_show(1005,"参数 wsm_code不能为空");
        }
        $wsm = Db::name("warehouse_info")->where(["wsm_code"=>$wsm_code])->find();
        if(empty($wsm)){
            return error_show(1005,"未找到仓库数据");
        }
        $contactor = isset($this->post['contactor']) && $this->post['contactor']!="" ? trim($this->post['contactor'])
            :"";
        $mobile = isset($this->post['mobile']) && $this->post['mobile']!="" ? trim($this->post['mobile']):"";
        $addr = isset($this->post['addr']) && $this->post['addr']!="" ? trim($this->post['addr']):"";
        $addr_code = isset($this->post['addr_code']) && $this->post['addr_code']!="" ? trim($this->post['addr_code']):"";
        if($info['is_th']==0 && $info['order_type']==2){
            if($contactor==''){
                return error_show(1005,"参数 contactor 不能为空");
            }
            if($mobile==''){
                return error_show(1005,"参数 mobile 不能为空");
            }
            if($addr==''){
                return error_show(1005,"参数 addr 不能为空");
            }
            if($addr_code==''){
                return error_show(1005,"参数 addr_code 不能为空");
            }
        }
        Db::startTrans();
        try{
            $info['status']=$info['order_type']==1?3:4;
            $info['updatetime']=date("Y-m-d H:i:s");
            $up =Db::name("order_return")->save($info);
            if($up){
                $returninfo = Db::name("order_returninfo")->where(["returnCode"=>$bkcode])->find();
                if(empty($returninfo)){
                    $returninfo=[
                        "returnCode"=>$bkcode,
                        "return_wsm"=>$wsm_code,
                        "contactor"=>$contactor,
                        "mobile"=>$mobile ,
                        "addr"=>$addr,
                        "addr_code"=>$addr_code,
                        "addtime"=>date("Y-m-d H:i:s")
                    ];
                }else{
                    $returninfo['return_wsm'] = $wsm_code;
                    $returninfo['contactor'] = $contactor;
                    $returninfo['mobile'] = $mobile;
                    $returninfo['addr'] = $addr;
                    $returninfo['addr_code'] = $addr_code;
                }
                $in=Db::name("order_returninfo")->save($returninfo);
                if($in){
                    Db::commit();
                    return app_show(0,"更新成功");
                }
            }
            Db::rollback();
                return error_show(1004,"更新失败");
        }catch (\Exception $e){
            Db::rollback();
            return error_show(1004,$e->getMessage());
        }

    }

    /**
     * @return \think\response\Json|void
     * @throws \think\db\exception\DataNotFoundException
     * @throws \think\db\exception\DbException
     * @throws \think\db\exception\ModelNotFoundException
     */
    public function addpost(){
        $bkcode = isset($this->post['returnCode']) && $this->post['returnCode']!="" ? trim($this->post['returnCode']):"";
        if($bkcode==""){
            return error_show(1005,"参数returnCode 不能为空");
        }
        $info = Db::name("order_return")->where(['returnCode'=>$bkcode])->find();
        if(empty($info)){
            return error_show(1005,"未找到售后数据");
        }
        $return_info = Db::name("order_returninfo")->where(['returnCode'=>$bkcode])->find();
        if(empty($return_info)){
            $return_info=[
                "returnCode"=>$bkcode,
                "return_wsm"=>'',
                "contactor"=>'',
                "mobile"=>'',
                "addr"=>'',
                "addr_code"=>'',
                "addtime"=>date("Y-m-d H:i:s"),
                "post_company"=>'',
                "post_code"=>'',
                "post_fee"=>'',
            ];
        }
          $post_own = isset($this->post['own']) &&$this->post['own']!='' ? trim($this->post['own']):"";
        if($post_own==''){
            return error_show(1005,"参数own不能为空");
        }
        $info['post_own'] = $post_own;
        $post_company = isset($this->post['company'])&&$this->post['company']!='' ? trim($this->post['company']):"";
        if($post_company==''){
            return error_show(1005,"参数company不能为空");
        }
        $return_info['post_company'] = $post_company;
        $post_code = isset($this->post['post_code'])&&$this->post['post_code']!='' ? trim($this->post['post_code']):"";
        if($post_code==''){
            return error_show(1005,"参数post_code不能为空");
        }
        $return_info['post_code'] = $post_code;
        $fee= isset($this->post['post_fee'])&&$this->post['post_fee']!=='' ? round($this->post['post_fee'],2):"";
        if($fee===''){
            return error_show(1005,"参数post_fee不能为空");
        }
        $return_info['post_fee'] = $fee;
        Db::startTrans();

        try{
            $info['status']=$info['order_type']==1?4:5;
            $info['updatetime']=date("Y-m-d H:i:s");
            $up =Db::name("order_return")->save($info);
            if($up){
                $in=Db::name("order_returninfo")->save($return_info);
                if($in){
                    $data=[
                        'thNo'=>makeNo("TH"),
                        "orderCode"=>$info['orderCode'],
                        "order_type"=>$info['order_type'],
                        "outCode"=>$info['outCode'],
                        "returnCode"=>$info['returnCode'],
                        "good_code"=>$info['good_code'],
                        "good_name"=>$info['good_name'],
                        "return_wsm"=>$return_info['return_wsm'],
                        "return_num"=>$info['error_num'],
                        "contactor"=>$return_info['contactor'],
                        "mobile"=>$return_info['mobile'],
                        "addr"=>$return_info['addr'],
                        "addr_code"=>$return_info['addr_code'],
                        "return_code"=>$info['error_code'],
                        "return_msg"=>$info['error_msg'],
                        "post_fee"=>$return_info['post_fee'],
                        "post_code"=>$return_info['post_code'],
                        "post_company"=>$return_info['post_company'],
                        "customer_code"=>$info['customer_code'],
                        "addtime"=>date("Y-m-d H:i:s"),
                        "updatetime"=>date("Y-m-d H:i:s")
                    ];
                    $back =Db::name("order_back")->insert($data);
                    if($back){
                        Db::commit();
                        return app_show(0,"更新成功");
                    }
                }
            }
            Db::rollback();
            return error_show(1004,"更新失败");
        }catch (\Exception $e){
            Db::rollback();
            return error_show(1004,$e->getMessage());
        }
    }

    /**
     * @return \think\response\Json|void
     * @throws \think\db\exception\DataNotFoundException
     * @throws \think\db\exception\DbException
     * @throws \think\db\exception\ModelNotFoundException
     */
    public function GysFeed(){
        $bkcode = isset($this->post['returnCode']) && $this->post['returnCode']!="" ? trim($this->post['returnCode']):"";
        if($bkcode==""){
            return error_show(1005,"参数returnCode 不能为空");
        }
        $info = Db::name("order_return")->where(['returnCode'=>$bkcode])->find();
        if(empty($info)){
            return error_show(1005,"未找到售后数据");
        }
        $isth = isset($this->post['is_th']) && $this->post['is_th']!="" ? intval($this->post['is_th']):"0";
        $contactor = isset($this->post['contactor']) && $this->post['contactor']!="" ? trim($this->post['contactor'])
            :"";
        $mobile = isset($this->post['mobile']) && $this->post['mobile']!="" ? trim($this->post['mobile']):"";
        $addr = isset($this->post['addr']) && $this->post['addr']!="" ? trim($this->post['addr']):"";
        $addr_code = isset($this->post['addr_code']) && $this->post['addr_code']!="" ? trim($this->post['addr_code']):"";
        $remark = isset($this->post['remark']) && $this->post['remark']!="" ? trim($this->post['remark']):"";
        if($isth==1){
            if($contactor==''){
                return error_show(1005,"参数 contactor 不能为空");
            }
            if($mobile==''){
                return error_show(1005,"参数 mobile 不能为空");
            }
            if($addr==''){
                return error_show(1005,"参数 addr 不能为空");
            }
            if($addr_code==''){
                return error_show(1005,"参数 addr_code 不能为空");
            }
        }
        Db::startTrans();
        try{
            $info['status']=3;
            $info['is_th']=$isth;
            $info['updatetime']=date("Y-m-d H:i:s");
            $up =Db::name("order_return")->save($info);
            if($up){
                $returninfo = Db::name("order_returninfo")->where(["returnCode"=>$bkcode])->find();
                if(empty($returninfo)){
                    $returninfo=[
                        "returnCode"=>$bkcode,
                        "return_wsm"=>'',
                        "contactor"=>$contactor,
                        "mobile"=>$mobile ,
                        "addr"=>$addr,
                        "addr_code"=>$addr_code,
                        "gys_remark"=>$remark,
                        "addtime"=>date("Y-m-d H:i:s")
                    ];
                }else{
                    $returninfo['return_wsm'] = '';
                    $returninfo['contactor'] = $contactor;
                    $returninfo['mobile'] = $mobile;
                    $returninfo['addr'] = $addr;
                    $returninfo['gys_remark'] = $remark;
                    $returninfo['addr_code'] = $addr_code;
                }
                $in=Db::name("order_returninfo")->save($returninfo);
                if($in){
                    Db::commit();
                    return app_show(0,"更新成功");
                }
            }
            Db::rollback();
            return error_show(1004,"更新失败");
        }catch (\Exception $e){
            Db::rollback();
            return error_show(1004,$e->getMessage());
        }
    }
}