<?php

namespace app\admin\controller;

use app\BaseController;
use think\App;
use think\facade\Db;

class Cat extends BaseController
{
public $post="";
public function __construct(App $app)
{
    parent::__construct($app);
    $this->post=$this->request->post();
}
public function list(){
    $where=[];
    $pid =  isset($this->post['pid']) &&$this->post['pid']!=="" ?intval($this->post['pid']): "";
    if($pid!==""){
        $where[]=["pid","=",$pid];
    }
    $cat_name=isset($this->post['cat_name']) && $this->post['cat_name'] !==""? intval($this->post['cat_name']) :"";
    if($cat_name!==""){
        $where[]=['cat_name',"like","%$cat_name%"];
    }
    $list = Db::name('cat')->where(['pid'=>$pid])->select();
    foreach ($list as $value) {
        $str = Db::name('cat')->where(['pid' => $value['id']])->select();
        foreach ($str as $stn) {
            $var = Db::name('cat')->where(['pid' => $stn['id']])->select();
        }
    }
    //var_dump(Db::name('cat')->getLastSql());
    $data = Db::name("cat")->where(['pid'=>0])->select();
    $vmp = [];
    foreach ($data as $sts){
        $vmp[]=stro($sts);
    }
    return app_show(0,"获取成功",$vmp);
}
public function plist(){
    $page = isset($this->post['page']) && $this->post['page'] !=="" ? intval($this->post['page']) :"1";
    $size = isset($this->post['size']) && $this->post['size'] !=="" ? intval($this->post['size']) :"10";
    $where =[];
    $cat_name=isset($this->post['cat_name']) && $this->post['cat_name'] !==""? trim($this->post['cat_name']) :"";
    if($cat_name!==""){
        $where[]=['cat_name',"like","%$cat_name%"];
    }
    $pid=isset($this->post['pid']) && $this->post['pid'] !==""? intval($this->post['pid']) :"";
    if($pid!==""){
        $where[]=['pid',"=",$pid];
    }
    $status=isset($this->post['status']) && $this->post['status'] !==""? intval($this->post['status']) :"";
    if($status!==""){
        $where[]=['status',"=",$status];
    }
    $count = Db::name("cat")->where($where)->count();
    $total = ceil($count / $size);
    $page = $page >= $total ? $total : $page;
    $list = Db::name('cat')->where($where)->page($page, $size)->select();
    return app_show(0, "获取成功", ['list' => $list, 'count' => $count]);
}
public function create()
{
    $cat_name = isset($this->post['cat_name']) && $this->post['cat_name'] !== "" ? trim($this->post['cat_name']) : "";
    if ($cat_name == "") {
        return error_show(1002, "参数cat_name不能为空");
    }
    $pid = isset($this->post['pid']) && $this->post['pid'] !== "" ? intval($this->post['pid']) : "";
    if ($pid === "") {
        return error_show(1002, "参数pid不能为空");
    }
    $level = isset($this->post['level']) && $this->post['level'] !== "" ? intval($this->post['level']) : "";

    $levl=Db::name('cat')->where(['id'=>$pid])->find();
    $level =1;
    if ($pid !== 0) {
        if(empty($levl)){
            return error_show(1002,"未找到父级数据");
        }
        $level =$levl['level']+1;
    }
    $rate = isset($this->post['rate']) && $this->post['rate'] !== "" ? intval($this->post['rate']) : "";
    $weight = isset($this->post['weight']) && $this->post['weight'] !== "" ? intval($this->post['weight']) : "0";
    $status = isset($this->post['status']) && $this->post['status'] !== "" ? intval($this->post['status']) : "1";
    $data = [
        "cat_name" => $cat_name,
        "pid" => $pid,
        "level" => $level,
        "rate" => $rate,
        "weight" => $weight,
        "status" => $status,
        "addtime" => date("Y-m-d H:i:s"),
        "updatetime" => date("Y-m-d H:i:s")
    ];
    $datainfo = Db::name('cat')->insert($data);
        if ($datainfo) {
            return error_show(0, "新建成功");
        } else {
            return error_show(1002, "新建失败");
        }
}
public function edit(){
    $id = isset($this->post['id']) && $this->post['id'] !==""? intval($this->post['id']) :"";
    $idinfo = Db::name('cat')->where(['id'=>$id])->find();
    if($idinfo==""){
        return error_show(1002,"未找到商品数据");
    }
    $cat_name= isset($this->post['cat_name']) && $this->post['cat_name'] !=="" ? trim($this->post['cat_name']) :"";
    if($cat_name==""){
        return error_show(1002,"参数cat_name不能为空");
    }
    $pid = isset($this->post['pid']) && $this->post['pid'] !=="" ? intval($this->post['pid']) :"";
    if($pid==""){
        return error_show(1002,"参数pid不能为空");
    }
    $level = isset($this->post['level']) && $this->post['level'] !=="" ? intval($this->post['level']) :"";
    $weight = isset($this->post['weight']) && $this->post['weight']!==""? intval($this->post['weight']):"0";
    $status = isset($this->post['status']) && $this->post['status'] !==""?intval($this->post['status']) :"1";
    $str = [
        "id"=>$id,
        "cat_name"=>$cat_name,
        "pid"=>$pid,
        "level"=>$level,
        "weight"=>$weight,
        "status"=>$status,
        "updatetime"=>date("Y-m-d H:i:s")
    ];
    $strinfo = Db::name('cat')->where(['id'=>$id])->save($str);
    if($strinfo){
        return error_show(0,"编辑成功");
    }else{
        return error_show(1002,"编辑失败");
    }
}
public function info(){
    $id = isset($this->post['id']) && $this->post['id'] !=="" ? intval($this->post['id']) :"";
    if($id==""){
        return error_show(1002,"参数id不能为空");
    }
    $idinfo = Db::name('cat')->where(['id'=>$id])->find();
    return app_show(0,"获取成功",$idinfo);
}
public function status(){
    $id = isset($this->post['id']) && $this->post['id'] !=="" ? intval($this->post['id']):"";
    if($id===""){
        return error_show(1002,"参数id不能为空");
    }
    $stn = Db::name('cat')->where(['id'=>$id])->find();
    if(empty($stn)){
        return error_show(1002,"未找到商品数据");
    }
    $status = isset($this->post['status']) && $this->post['status'] !=="" ? intval($this->post['status']) :"";
    if($status===""){
        return error_show(1002,"参数status不能为空");
    }
    $stn['status']=$status;
    $stn['updatetime']=date("Y-m-d H:i:s");
    $str = Db::name('cat')->where(['id'=>$id])->save($stn);
    if($str){
        return error_show(0,"状态更新成功");
    }else{
        return error_show(1002,"状态更新失败");
    }
}
}