<?php


namespace app\admin\controller;

use think\facade\Db;
use think\App;
class Reorder extends \app\BaseController
{
    public $post=[];
    public function __construct(App $app)
    {
        parent::__construct($app);
        $this->post =$this->request->post();
    }

    public function create(){
        $ordeCode = isset($this->post['orderCode']) &&$this->post['orderCode']!=''?trim($this->post['orderCode']) :"";
        if($ordeCode==''){
            return error_show(1004,"参数orderCode 不能为空");
        }
        $order= Db::name("sale")->where(["orderCode"=>$ordeCode,"is_del"=>0])->find();

        if(empty($order)){
            return error_show(1005,"未找到订单数据");
        }
        $errorCode = isset($this->post['errorCode']) &&$this->post['errorCode']!=''?trim($this->post['errorCode']) :"";
        if($ordeCode==''){
            return error_show(1004,"参数orderCode 不能为空");
        }
        $error =Db::name('result_info')->where(["result_code"=>$errorCode,"is_del"=>0])->find();
        if(empty($error)){
            return error_show(1005,"未找到退货原因数据");
        }
        $remark =isset($this->post['remark']) &&$this->post['remark']!=''?trim($this->post['remark']) :"";
        $data = isset($this->post['list'])&&$this->post['list']!='' ? $this->post['list'] :'';
        if($data=='' || empty($data)){
            return error_show(1005,"参数list不能为空");
        }
        $addr = isset($this->post['addr'])&&$this->post['addr']!='' ? $this->post['addr'] :'';
        if($addr=='' || empty($addr)){
            return error_show(1005,"参数addr不能为空");
        }
        $token = isset($this->post['token'])&&$this->post['token']!='' ? trim($this->post['token']):"";
        if($token==''){
            return error_show(1005,"参数token不能为空");
        }
        $user =GetUserInfo($token);
        if(empty($user)||$user['code']!=0){
            return error_show(1002,"申请人数据不存在");
        }
        $rm= isset($user["data"]['id']) ?  $user["data"]['id'] : "";
        $ri= isset($user["data"]['nickname']) ?  $user["data"]['nickname'] : "";
        $total = array_sum(array_column($data,"return_num"));
        $addrnum = array_sum(array_column($addr,"return_num"));
        if($total!=$addrnum){
            return error_show(1002,"仓库退货数据与地址退货数据不一致");
        }
     //   var_dump($order['good_code']);
        $returnCode=makeNo("RXS");
        Db::startTrans();
        try{
            $in = [
                "returnCode"=>$returnCode,
                "orderCode"=>$ordeCode,
                "good_code"=>$order['good_code'],
                "good_name"=>$order['good_name'],
                "apply_id"=>$rm,
                "apply_name"=>$ri,
                "error_code"=>$errorCode,
                "num"=>$total,
                "remark"=>$remark,
                "order_type"=>1,
                "status"=>0,
                "is_del"=>0,
                "addtime"=>date("Y-m-d H:i:s"),
                "updatetime"=>date("Y-m-d H:i:s")
            ];
            $create = Db::name("sale_return")->insert($in);
            if($create){
                $addrinfo=[];
                foreach ($addr as $value){
                    $addrorder= Db::name("order_addr")->where(['orderCode'=>$ordeCode,"id"=>$value['addrid']])
                        ->find();
                    if(empty($addrorder)){
                        Db::rollback();
                        return error_show(1002,"订单地址数据不存在");
                    }
                    $total = Db::name("sale_returnaddr")->where(['orderCode'=>$ordeCode,"id"=>$value['addrid'],"is_del"=>0])
                        ->sum("return_num");
                    if($addrorder['receipt_quantity']-$total<$value['return_num']){
                        Db::rollback();
                        return error_show(1002,"订单地址退货数量超出发货数量");
                    }
                    $temp=[];
                    $temp['returnCode']=$returnCode;
                    $temp['orderCode']=$ordeCode;
                    $temp['addrid']=$value['addrid'];
                    $temp['return_num']=$value['return_num'];
                    $temp['send_num']= $addrorder['receipt_quantity'];
                    $temp['addtime']= date("Y-m-d H:i:s");
                    $temp['updatetime']= date("Y-m-d H:i:s");
                    $addrinfo[]=$temp;
                }
                $return = Db::name("sale_returnaddr")->insertAll($addrinfo);
                if($return<=0){
                    Db::rollback();
                    return error_show(1002,"订单地址退货数据更新失败");
                }
                $info=[];
                foreach ($data as $value){
                    $wsmorder= Db::name("sale_info")->where(['orderCode'=>$ordeCode,"wsm_code"=>$value['wsm_code']])
                        ->find();
                    if(empty($wsmorder)){
                        Db::rollback();
                        return error_show(1002,"订单仓库数据不存在");
                    }
                    $total_wsm = Db::name("sale_returninfo")->where(['orderCode'=>$ordeCode,"wsm_code"=>$value['wsm_code'],"is_del"=>0])
                        ->sum("return_num");
                    if($wsmorder['num']-$total_wsm<$value['return_num']){
                        Db::rollback();
                        return error_show(1002,"仓库退货数量超出发货数量");
                    }
                    $temp=[];
                    $temp['returnCode']=$returnCode;
                    $temp['orderCode']=$ordeCode;
                    $temp['wsm_code']=$value['wsm_code'];
                    $temp['return_num']=$value['return_num'];
                    $temp['total_num']= $wsmorder['num'];
                    $temp['addtime']= date("Y-m-d H:i:s");
                    $temp['updatetime']= date("Y-m-d H:i:s");
                    $info[]=$temp;
                }
                $return = Db::name("sale_returninfo")->insertAll($info);
                if($return){
                    Db::commit();
                    return app_show(0,"退货单新建成功");
                }
            }
            Db::rollback();
            return error_show(1005,"退货单新建失败");
        }catch (\Exception $e){
            Db::rollback();
            return error_show(1005,$e->getMessage());
        }
    }

    public function list(){
        $page = isset($this->post['page']) && $this->post['page'] !=="" ? intval($this->post['page']):"1";
        $size = isset($this->post['size']) && $this->post['size'] !=="" ? intval($this->post['size']):"10";
        $where =[['is_del',"=",0]];
        $bkcode = isset($this->post['returnCode']) && $this->post['returnCode']!="" ? trim($this->post['returnCode']):"";
        if($bkcode!=""){
            $where[]=['returnCode',"like", "%{$bkcode}%"];
        }
        $status = isset($this->post['status']) && $this->post['status']!=="" ? intval($this->post['status']):"";
        if($status!==""){
            $where[]=['status',"=", $status];
        }
        $orderCode = isset($this->post['orderCode']) && $this->post['orderCode']!="" ? trim($this->post['orderCode'])
            :"";
        if($orderCode!=""){
            $where[]=['orderCode',"like", "%{$orderCode}%"];
        }
        $apply_name = isset($this->post['apply_name']) && $this->post['apply_name']!="" ? trim($this->post['apply_name'])
            :"";
        if($apply_name!=""){
            $where[]=['apply_name',"like", "%{$apply_name}%"];
        }
        $start =isset($this->post['start'])&&$this->post['start']!='' ? $this->post['start']:"";
        if($start!==""){
            $where[]=['addtime',">=", $start];
        }
        $end =isset($this->post['end'])&&$this->post['end']!='' ? $this->post['end']:"";
        if($end!==""){
            $where[]=['addtime',"<=", $end];
        }
        $count=Db::name("sale_return")->where($where)->count();
        $total = ceil($count/$size);
        $page = $total>=$page ? $page :$total;
        $list = Db::name("sale_return")->where($where)->order("addtime desc")->page($page,$size)->select();
       // echo Db::name("sale_return")->getLastSql();
        $data=[];
        foreach ($list as $value){
            $value['error_msg']='';
            if($value['error_code']!=''){
                $error = Db::name("result_info")->where(["result_code"=>$value['error_code']])->find();
                $value['error_msg']= isset($error['result'])?$error['result']:"";
            }
            $order =Db::name("sale")->where(["orderCode"=>$value['orderCode'],"is_del"=>0])->find();
            $value['sale_price'] = isset($order['sale_price']) ?$order['sale_price']:0;
            $value['return_total'] =$value['sale_price']*$value['num'] ;
            $value['total_num'] =$order['good_num'] ;
            $data[]=$value ;
        }
        return app_show(0,"获取成功",['list'=>$data,"count"=>$count]);
    }

    public function info(){
        $code =  isset($this->post['returnCode']) && $this->post['returnCode'] !=="" ? trim($this->post['returnCode'])
            :"";
        if($code==""){
            return error_show(1004,"参数returnCode不能为空");
        }
        $info = Db::name("sale_return")->where(["returnCode"=>$code,"is_del"=>0])->find();
       if(empty($info)){
           return error_show(1004,"未找到退货数据");
       }
       $orderinfo = Db::name("sale")->where(["orderCode"=>$info["orderCode"]])->find();
       $info['good_code'] = isset($orderinfo['good_code'])?$orderinfo['good_code']:'';
       $info['good_name'] = isset($orderinfo['good_name'])?$orderinfo['good_name']:'';
       $info['good_num'] = isset($orderinfo['good_num'])?$orderinfo['good_num']:'';
       $info['sale_price'] = isset($orderinfo['sale_price'])?$orderinfo['sale_price']:'0';
       $info['return_total'] = $info['sale_price']*$info['num'] ;
       $info['send_num'] = isset($orderinfo['send_num'])?$orderinfo['send_num']:'0';
       $info['wsend_num'] = isset($orderinfo['wsend_num'])?$orderinfo['wsend_num']:'0';
       $info['send_status'] = isset($orderinfo['send_status'])?$orderinfo['send_status']:'';
       $info['total_price'] = isset($orderinfo['total_price'])?$orderinfo['total_price']:'0';
       $info['post_fee'] = isset($orderinfo['post_fee'])?$orderinfo['post_fee']:'0';
       $info['customer_code'] = isset($orderinfo['customer_code'])?$orderinfo['customer_code']:'';
        $info['customer_name']='';
        if(isset($orderinfo['customer_code'])&&$orderinfo['customer_code']!=''){
            $customerinfo = Db::name("customer_info")->where(['companyNo'=>$orderinfo['customer_code']])->find();
            $info['customer_name'] = isset($customerinfo['companyName']) ? $customerinfo['companyName']:"";
        }
        $info['error_msg']='';
        if($info['error_code']!=''){
            $error = Db::name("result_info")->where(["result_code"=>$info['error_code']])->find();
            $info['error_msg']= isset($error['result'])?$error['result']:"";
        }
        $wsm_return = Db::name("sale_returninfo")->where(["returnCode"=>$info["returnCode"],"is_del"=>0])->select()->toArray();
        $wsm=[];
        if(!empty($wsm_return)){

            foreach ($wsm_return as $value){
                $value['wsm_name']="";
                $value['wsm_supplier']="";
                $value['wsm_supplierNo']="";
                if($value['wsm_code']!=""){
                    $wsmcode = Db::name("warehouse_info")->alias("a")->leftJoin("supplier b","a.supplierNo=b.code")
                        ->where(["a.wsm_code"=>$value['wsm_code']])->field("a.name as wsm_name,b.name,b.code")->find();
                    $value['wsm_name'] =isset($wsmcode['wsm_name']) ? $wsmcode['wsm_name']:"";
                    $value['wsm_supplier'] =isset($wsmcode['name']) ? $wsmcode['name']:"";
                    $value['wsm_supplierNo'] =isset($wsmcode['code']) ? $wsmcode['code']:"";
                }
                $wsm[]=$value;
            }
        }
        $info['wsminfo']=$wsm;
        $addr =Db::name("sale_returnaddr")->where(["returnCode"=>$info["returnCode"],"is_del"=>0])->select()->toArray();
        $addrinfo=[];
        if(!empty($addr)){
            foreach ( $addr as $value){
                $addrlist = Db::name("order_addr")->where(["id"=>$value["addrid"]])->find();
                $value['addr']=isset($addrlist['addr'])?$addrlist['addr']:"";
                $value['addr_code']=isset($addrlist['addr_code'])?$addrlist['addr_code']:"";
                $value['contactor']=isset($addrlist['contactor'])?$addrlist['contactor']:"";
                $value['mobile']=isset($addrlist['mobile'])?$addrlist['mobile']:"";
                $value['post_fee']=isset($addrlist['post_fee'])?$addrlist['post_fee']:"";
                $value['addive_time']=isset($addrlist['addive_time'])?$addrlist['addive_time']:"";
                $value['customer_code']=isset($addrlist['customer_code']) ?$addrlist['customer_code']:"" ;
                $customer = Db::name("customer_info")->where(['companyNo'=>$addrlist['customer_code']])->find();
                $value['customer_name'] = isset($customer['companyName']) ? $customer['companyName']:"";
                $addrinfo[]=$value;
            }

        }
        $info['addrinfo']=$addrinfo;
        return app_show(0,"获取成功",$info);
    }

    /**
     * @return \think\response\Json|void
     * @throws \think\db\exception\DataNotFoundException
     * @throws \think\db\exception\DbException
     * @throws \think\db\exception\ModelNotFoundException
     */
    public function delete(){
        $code =  isset($this->post['returnCode']) && $this->post['returnCode'] !=="" ? trim($this->post['returnCode'])
            :"";
        if($code==""){
            return error_show(1004,"参数returnCode不能为空");
        }
        $info = Db::name("sale_return")->where(["returnCode"=>$code,"is_del"=>0])->find();
        if(empty($info)){
            return error_show(1004,"未找到退货数据");
        }
        $info["is_del"]=1;
        $info["updatetime"]=date("Y-m-d H:i:s");
        $del = Db::name("sale_return")->save($info);
        if($del){
            return app_show(0,"删除成功");
        }else{
            return error_show(1004,"删除失败");
        }
    }

    /**审核
     * @return \think\response\Json|void
     * @throws \think\db\exception\DataNotFoundException
     * @throws \think\db\exception\DbException
     * @throws \think\db\exception\ModelNotFoundException
     */
    public function exam(){
        $code =  isset($this->post['returnCode']) && $this->post['returnCode'] !=="" ? trim($this->post['returnCode'])
            :"";
        if($code==""){
            return error_show(1004,"参数returnCode不能为空");
        }
        $info = Db::name("sale_return")->where(["returnCode"=>$code,"is_del"=>0])->find();
        if(empty($info)){
            return error_show(1004,"未找到退货数据");
        }
        $status =  isset($this->post['status']) && $this->post['status'] !=="" ? intval($this->post['status'])
            :"";
        if($status===""){
            return error_show(1004,"参数status不能为空");
        }
        $remark =  isset($this->post['remark']) && $this->post['remark'] !="" ? trim($this->post['remark']) :"";
        $info['status'] =$status;
        $info['remark'] =$remark;
        $info["updatetime"]=date("Y-m-d H:i:s");
        $up = Db::name("sale_return")->save($info);
        if($up){
            return app_show(0,"更新成功");
        }else{
            return error_show(1004,"更新失败");
        }
    }
}